
var currentVideoSrc = null;

function detectVideoByVideoTag() {
    var videoElements = document.getElementsByTagName('video');
    if (!videoElements) {
        return;
    }
    window.detectJsInterface.markHasVideo();
    console.log('video标签 length = ', videoElements.length);
    for (var i = 0; i < videoElements.length; i++) {
        var eleVideo = videoElements[i];
        if (!eleVideo.hasAttribute('playEventL')) {
            eleVideo.setAttribute('playEventL', 1);
            eleVideo.addEventListener('playing', function (e) {
                reportVideo(e.srcElement);
            });
        }
    }
}

function reportVideo(v) {
    console.log('reportVideo readyState = ', v.readyState);
    if (v.src === currentVideoSrc) {
        console.log('reportVideo 重复 src = ', v.src, v.currentSrc);
        return;
    }
    console.log('reportVideo: src = ', v.src, v.currentSrc);
    currentVideoSrc = v.src;
    window.detectJsInterface.onDetect(v.src, '', v.duration);
}

function onLoadListener() {
    window.addEventListener('DOMContentLoaded', function () {
         console.log('DOMContentLoaded', document.URL);
    });
    window.addEventListener('load', function () {
         console.log('load', document.URL);
         observeDomChange();
    });
    window.addEventListener('beforeunload', function () {
         console.log('beforeunload', document.URL);
    });
    window.addEventListener('unload', function () {
         console.log('unload', document.URL);
    });
}

function observeDomChange() {
    let observer = new MutationObserver(debounce(100));
    let article = document.body;
    let options = {
      'childList': true,
      'subtree': true
    };
    observer.observe(article, options);
}

function debounce(timeout) {
    var timer;
    return function () {
        if (timer) {
            clearTimeout(timer);
        }
        timer = setTimeout(function () {
            detectVideoByVideoTag();
        }, timeout);
    };
}

console.log('url = ', document.URL);

onLoadListener();



