
var currentVideoSrc = null;

function detectVideo() {
    var videoElements = document.getElementsByTagName('video');
    if (!videoElements) {
        return;
    }
    window.detectJsInterface.markHasVideo();
    var list = document.querySelectorAll('div.swiper-slide-active video');
    var length = list.length;
    if (length === 0) {
        list = document.querySelectorAll('video');
        console.log('sharing-main-video-el');
        length = list.length;
    }
    console.log('有' + length + '个video标签');
     if (length === 0) {
        if (currentVideoSrc != null) {
            currentVideoSrc = null;
            window.detectJsInterface.empty();
        }
        return;
     }
    var s = list[0].currentSrc;
    var duration = list[0].duration;
    console.log('video.src = ', s);
    console.log('video.duration = ', duration);
    if (s === currentVideoSrc) {
       return;
    }
    currentVideoSrc = s;
    var title = getTitle();
    window.detectJsInterface.onDetect(s, title, duration);
}

function getTitle() {
    var list = document.querySelectorAll('div.swiper-slide-active h1.bottom-desc');
    if (!list || !list[0]) {
        return '';
    }
    var outTxt = list[0].outerHTML;
    console.log('outerHTML', outTxt);
    var dd = outTxt.replace(/<\/?.+?>/g, '');
    console.log('title = ', dd);
    return dd;
}

function onLoadListener() {
    window.addEventListener('DOMContentLoaded', function () {
         console.log('DOMContentLoaded', document.URL);
    });
    window.addEventListener('load', function () {
         console.log('load', document.URL);
         observeDomChange();
    });
    window.addEventListener('beforeunload', function () {
         console.log('beforeunload', document.URL);
    });
    window.addEventListener('unload', function () {
         console.log('unload', document.URL);
    });
}

function observeDomChange() {
    let observer = new MutationObserver(debounce(100));
    let article = document.body;
    let options = {
      'childList': true,
      'subtree': true
    };
    observer.observe(article, options);
}

function debounce(timeout) {
    var timer;
    return function () {
        if (timer) {
            clearTimeout(timer);
        }
        timer = setTimeout(function () {
            detectVideo();
        }, timeout);
    };
}

console.log('url = ', document.URL);

onLoadListener();



