
function videoTagScan() {
    var videoElements = document.getElementsByTagName('video');
    if (!videoElements) {
        console.log('video tag scan len = 0');
        return;
    }
    console.log('video tag scan len = ', videoElements.length);
    window.detectJsInterface.markHasVideo();
}

// 设置observer的配置选项
var config = { childList: true, subtree: true };
// 当节点发生变化时的需要执行的函数
var callback = function (mutationsList, observer) {
    videoTagScan();
};
// 创建一个observer示例与回调函数相关联
var observer = new MutationObserver(callback);

function onLoadListener() {
    window.addEventListener('load', function () {
         console.log('video tag scan load', document.URL);
         videoTagScan();
         observer.observe(document.body, config);
    });
    window.addEventListener('unload', function () {
         console.log('video tag scan unload', document.URL);
         observer.disconnect();
    });
}
onLoadListener();